#ifndef CCONFLICTSDIALOG
#define CCONFLICTSDIALOG
#include <gtkmm.h>
#include <vector>

// Dialog box to present package conflicts to the user and ask if they
// really want to keep going, or just hang up their towel now.
// See COPYING for license information.

class CConflictsDialog : public Gtk::Dialog
{
public:
	CConflictsDialog(std::vector<struct_package>& installs, std::vector<struct_package>& removals, packagemap_t& packages);

	bool		Continue;	// Is death really the end?
protected:
	Gtk::Label	_Label;
};

CConflictsDialog::CConflictsDialog(std::vector<struct_package>& installs, std::vector<struct_package>& removals, packagemap_t& packages) :
Continue(true)
{
	set_border_width(6);
	add_button(Gtk::Stock::NO, -4);
	add_button(Gtk::Stock::YES, 1);
	set_default_response(-4);
	get_vbox()->pack_start(_Label);
	show_all_children();

	// Find the conflicts, create a list of them.
	Glib::ustring	_text;
	for ( int i = 0; i < installs.size(); i++ ) {
		Glib::ustring	_cons = installs[i].cons + ",";
		while ( _cons.length() ) {
			bool	_conflicts = false;
			if ( packages.find(_cons.substr(0, _cons.find(','))) != packages.end() &&
				packages[_cons.substr(0, _cons.find(','))].installedversion.length() )
				_conflicts = true;
			for ( int k = 0; k < installs.size(); k++ )
				if ( installs[k].name == _cons.substr(0, _cons.find(',')) ) _conflicts = true;
			for ( int k = 0; k < removals.size(); k++ )
				if ( removals[k].name == _cons.substr(0, _cons.find(',')) ) _conflicts = false;
			if ( _conflicts )
				_text += "\n\t" + installs[i].name + " conflicts with: " + _cons.substr(0, _cons.find(','));
			_cons.erase(0, _cons.find(',') + 1);
		}
	}

	if ( _text.length() > 0 ) {	// There were some conflicts
		_text = "There are some package conflicts:" + _text + "\n\nDo you really want to continue?";
		_Label.set_text(_text);
		if ( run() == -4 ) Continue = false;	// The user chickened out.
		hide();
	}
}

#endif
