#ifndef CPKGINSTALLER_H
#define CPKGINSTALLER_H
#include <iostream>

// This class provides a simple way to install a package.
// Perhaps it could be done better using threading, but
// this will hopefully work too.
// See COPYING for license information.

class CPkgInstaller
{
public:
	CPkgInstaller(std::string file, bool upgrade);
	~CPkgInstaller();
	float	Iteration();
protected:
	std::string	_File;
};

CPkgInstaller::CPkgInstaller(std::string file, bool upgrade) :
_File(file.substr(file.rfind('/') + 1))
{	// Set "upgrade" to true if this package is an update.
	if ( upgrade ) WRITELOG("Updating package: " + _File);
	else  WRITELOG("Installing package: " + _File);
	std::string	_cmd = "rm -f " + TMPFILE(_File + ".done");
	system(_cmd.c_str());
	_cmd = "/sbin/upgradepkg --install-new --reinstall " + file + " > " + TMPFILE(_File + ".log") + " && touch " + TMPFILE(_File + ".done") + " &";
	system(_cmd.c_str());
}

CPkgInstaller::~CPkgInstaller()
{
	system(std::string("rm -f " + TMPFILE(_File + ".done")).c_str());
	system(std::string("rm -f " + TMPFILE(_File + ".log")).c_str());
}

float CPkgInstaller::Iteration()
{	// Check for successful or failed install
	std::ifstream	_ifcheck;
	std::string	_instr;
	_ifcheck.open(TMPFILE(_File + ".log").c_str(), std::ios_base::in);
	while ( _ifcheck.is_open() && !_ifcheck.eof() ) {
		getline(_ifcheck, _instr);
		if ( !_instr.find("Cannot install") || !_instr.find("Unable to install") ) {
			WRITELOG("Failed to install: " + _File);
			return -1.0f;
		}
	}
	_ifcheck.close();
	_ifcheck.open(TMPFILE(_File + ".done").c_str(), std::ios_base::in);
	if ( _ifcheck.is_open() ) {
		WRITELOG("Finished installing: " + _File);
		return 2.0f;
	}
	_ifcheck.close();
	return 0.0f;
}

#endif
